# Traffic Sources   VPCs

## List All VPCs

> Return a list of all Cloud Sources.   Supports filtering by flowtype, flowresource, traffictype, and logtype (all together or separate).<br>

```json
{"openapi":"3.0.0","info":{"title":"Netography APIs","version":"1.0"},"tags":[{"name":"Traffic Sources - VPCs"}],"servers":[{"url":"https://api.netography.com","description":"Netography API"}],"security":[{"BearerAuth":[]}],"components":{"securitySchemes":{"BearerAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}}},"paths":{"/api/v1/vpc":{"get":{"operationId":"v1_vpc_get","summary":"List All VPCs","description":"Return a list of all Cloud Sources.   Supports filtering by flowtype, flowresource, traffictype, and logtype (all together or separate).\n","tags":["Traffic Sources - VPCs"],"parameters":[{"name":"flowtype","in":"query","description":"Filter by flow type (e.g., aws, azure, gcp, etc.)","required":false,"schema":{"type":"string"}},{"name":"flowresource","in":"query","description":"Filter by flow resource (e.g., s3, kinesis, etc.)","required":false,"schema":{"type":"string"}},{"name":"traffictype","in":"query","description":"Filter by traffic type (e.g., dns, flow)","required":false,"schema":{"type":"string"}},{"name":"logtype","in":"query","description":"Filter by log type (e.g., gcp-dns-query-log, etc.)","required":false,"schema":{"type":"string"}}],"responses":{"200":{"description":"List of VPCs Requested","content":{"application/json":{"schema":{"type":"object","additionalProperties":false,"properties":{"meta":{"type":"object","additionalProperties":false,"readOnly":true,"properties":{"code":{"description":"API response code.  200 ok, 400 you did something wrong.  500 we did something wrong","type":"integer","readOnly":true,"format":"int32"},"count":{"description":"Number of documents retrieved or updated.","type":"integer","readOnly":true,"format":"int32"}}},"data":{"description":"Result set from API call","type":"array","maxItems":1000,"items":{"additionalProperties":false,"properties":{"id":{"description":"VPC id","readOnly":true,"type":"string"}},"oneOf":[{"description":"AWS Kinesis Parameters.","type":"object","required":["flowtype","flowresource","name","enabled","samplerate","region","shardid","stream","awsauthtype"],"additionalProperties":false,"properties":{"flowtype":{"description":"The VPC's flowtype","type":"string","enum":["aws"]},"flowresource":{"description":"The VPC's resource used to transmit flow events.","type":"string","enum":["kinesis"]},"traffictype":{"description":"The VPC's traffic type. Can't be changed at updating.","type":"string","enum":["flow"]},"name":{"description":"The name of the VPC. Eg. prod-vpc-east","type":"string"},"enabled":{"description":"If this VPC is enabled or disabled.","type":"boolean"},"samplerate":{"description":"The samplerate of flows this VPC will send. Between 1 and 65535.","type":"integer","format":"int32","minimum":1,"maximum":65535},"region":{"type":"string","description":"The region the VPC is in. See <a href=\"/netography-docs/reference/get_api-v1-vpc-regions-flowtype\">Get VPC regions by flowtype</a> for a list of valid regions.\n"},"shardid":{"type":"string","description":"Kinesis shard id"},"stream":{"description":"Kinesis stream","type":"string"},"tags":{"description":"An array of strings to tag every flow from this VPC with.","type":"array","items":{"type":"string"}},"awsauthtype":{"description":"<p>The method of authentication to use with AWS.  Valid options are:</p> <ul> <li><code>AccessKey</code>: indicates key/secret auth. <code>accesskeyid</code> and <code>accesssecret</code> fields are then required.</li> <li><code>RoleARN</code> indicates that role auth.  The <code>role</code> object is then required.</li> </ul>\n","type":"string","enum":["AccessKey","RoleARN"]},"accesskeyid":{"description":"AWS accesskey id.  Required for <code>AccessKey</code> auth type.","type":"string"},"accesssecret":{"description":"AWS Access secret.  Required for <code>AccessKey</code> auth type.","type":"string"},"role":{"description":"object containing role authentication data.  Required for <code>RoleARN</code> auth type.","type":"object","properties":{"arn":{"description":"ARN used to authenticate the flow source","type":"string"}}}}},{"description":"AWS S3 Parameters","type":"object","required":["flowtype","flowresource","name","enabled","samplerate","bucket","bucketregion","region","awsauthtype"],"properties":{"flowtype":{"description":"The VPC's flowtype","type":"string","enum":["aws"]},"flowresource":{"description":"The VPC's resource used to transmit flow events.","type":"string","enum":["s3"]},"traffictype":{"description":"The VPC's traffic type. Can't be changed at updating.","type":"string","enum":["flow","dns"]},"name":{"description":"The name of the VPC. Eg. prod-vpc-east","type":"string"},"enabled":{"description":"If this VPC is enabled or disabled.","type":"boolean"},"samplerate":{"description":"The samplerate of flows this VPC will send. Between 1 and 65535.","type":"integer","format":"int32","minimum":1,"maximum":65535},"bucket":{"type":"string","description":"S3 bucket"},"bucketregion":{"type":"string","description":"Region this S3 bucket is in."},"hive":{"type":"string","description":"S3 Hive-compatible prefix"},"prefix":{"type":"string","description":"S3 flow log path prefix"},"region":{"type":"string","description":"The region the VPC is in. See <a href=\"/netography-docs/reference/get_api-v1-vpc-regions-flowtype\">Get VPC regions by flowtype</a> for a list of valid regions.\n"},"sqsurl":{"type":"string","description":"SQS URL of S3 events"},"tags":{"description":"An array of strings to tag every flow from this VPC with.","type":"array","items":{"type":"string"}},"awsauthtype":{"description":"<p>The method of authentication to use with AWS.  Valid options are:</p> <ul> <li><code>AccessKey</code>: indicates key/secret auth. <code>accesskeyid</code> and <code>accesssecret</code> fields are then required.</li> <li><code>RoleARN</code> indicates that role auth.  The <code>role</code> object is then required.</li> </ul>\n","type":"string","enum":["AccessKey","RoleARN"]},"accesskeyid":{"description":"AWS accesskey id.  Required for <code>AccessKey</code> auth type.","type":"string"},"accesssecret":{"description":"AWS Access secret.  Required for <code>AccessKey</code> auth type.","type":"string"},"role":{"description":"object containing role authentication data.  Required for <code>RoleARN</code> auth type.","type":"object","properties":{"arn":{"description":"ARN used to authenticate the flow source","type":"string"}}},"vpcid":{"description":"VPC ID of the source, applicable and required only for dns traffictype","type":"string"}}},{"description":"Azure Blobstorage Parameters","type":"object","required":["flowtype","flowresource","name","enabled","samplerate","region","accountname","accountkey","containername","networksecuritygroup","resourcegroup","subscriptionid"],"additionalProperties":false,"properties":{"flowtype":{"description":"The VPC's flowtype","type":"string","enum":["azure"]},"flowresource":{"description":"The VPC's resource used to transmit flow events.","type":"string","enum":["blobstorage"]},"traffictype":{"description":"The VPC's traffic type. Can't be changed at updating.","type":"string","enum":["flow"]},"name":{"description":"The name of the VPC. Eg. prod-vpc-east","type":"string"},"enabled":{"description":"If this VPC is enabled or disabled.","type":"boolean"},"samplerate":{"description":"The samplerate of flows this VPC will send. Between 1 and 65535.","type":"integer","format":"int32","minimum":1,"maximum":65535},"region":{"type":"string","description":"The region the VPC is in. See <a href=\"/netography-docs/reference/get_api-v1-vpc-regions-flowtype\">Get VPC regions by flowtype</a> for a list of valid regions.\n"},"accountname":{"type":"string","description":"Azure Storage Account's Access Name"},"accountkey":{"type":"string","description":"Azure Storage Account's Access Key"},"containername":{"type":"string","description":"Azure Storage Account's Container Name"},"networksecuritygroup":{"type":"string","description":"Azure Network Security Group's Name"},"resourcegroup":{"type":"string","description":"Azure Network Security Group's Resource Group"},"subscriptionid":{"type":"string","description":"Azure Network Security Group's subscription ID"},"tags":{"description":"An array of strings to tag every flow from this VPC with.","type":"array","items":{"type":"string"}}}},{"description":"GCP PubSub Parameters","type":"object","required":["flowtype","flowresource","name","enabled","samplerate","projectid","subid"],"additionalProperties":false,"properties":{"flowtype":{"description":"The VPC's flowtype","type":"string","enum":["gcp"]},"flowresource":{"description":"The VPC's resource used to transmit flow events.","type":"string","enum":["pubsub"]},"traffictype":{"description":"The VPC's traffic type. Can't be changed at updating.","type":"string","enum":["flow","dns"]},"name":{"description":"The name of the VPC. Eg. prod-vpc-east","type":"string"},"enabled":{"description":"If this VPC is enabled or disabled.","type":"boolean"},"samplerate":{"description":"The samplerate of flows this VPC will send. Between 1 and 65535.","type":"integer","format":"int32","minimum":1,"maximum":65535},"region":{"type":"string","description":"The region the VPC is in. See <a href=\"/netography-docs/reference/get_api-v1-vpc-regions-flowtype\">Get VPC regions by flowtype</a> for a list of valid regions.\n"},"projectid":{"type":"string","description":"GCP Project ID"},"subid":{"type":"string","description":"GCP PubSub Subscription ID"},"samplepercent":{"description":"Sample Rate Percent","type":"integer","format":"int32","minimum":1,"maximum":100},"tags":{"description":"An array of strings to tag every flow from this VPC with.","type":"array","items":{"type":"string"}}}},{"description":"IBM Objectstorage Parameters","type":"object","required":["flowtype","flowresource","name","enabled","samplerate","region","apikey","bucket","serviceinstanceid"],"additionalProperties":false,"properties":{"flowtype":{"description":"The VPC's flowtype","type":"string","enum":["ibm"]},"flowresource":{"description":"The VPC's resource used to transmit flow events.","type":"string","enum":["objectstorage"]},"traffictype":{"description":"The VPC's traffic type. Can't be changed at updating.","type":"string","enum":["flow"]},"name":{"description":"The name of the VPC. Eg. prod-vpc-east","type":"string"},"enabled":{"description":"If this VPC is enabled or disabled.","type":"boolean"},"samplerate":{"description":"The samplerate of flows this VPC will send. Between 1 and 65535.","type":"integer","format":"int32","minimum":1,"maximum":65535},"region":{"type":"string","description":"The region the VPC is in. See <a href=\"/netography-docs/reference/get_api-v1-vpc-regions-flowtype\">Get VPC regions by flowtype</a> for a list of valid regions.\n"},"apikey":{"type":"string","description":"IBM Objectstorage API key that is associated for the Service ID."},"bucket":{"type":"string","description":"The Objectstorage bucket name."},"prefix":{"type":"string","description":"Flow log path prefix"},"serviceinstanceid":{"type":"string","description":"Unique identifier for the instance of Object Storage the credential accesses. This is also referred to as a service credential."},"tags":{"description":"An array of strings to tag every flow from this VPC with.","type":"array","items":{"type":"string"}}}},{"description":"Oracle Objectstorage Parameters","type":"object","required":["flowtype","flowresource","name","enabled","samplerate","region","bucket","tenancy","userid"],"additionalProperties":false,"properties":{"flowtype":{"description":"The VPC's flowtype","type":"string","enum":["oracle"]},"flowresource":{"description":"The VPC's resource used to transmit flow events.","type":"string","enum":["objectstorage"]},"traffictype":{"description":"The VPC's traffic type. Can't be changed at updating.","type":"string","enum":["flow"]},"name":{"description":"The name of the VPC. Eg. prod-vpc-east","type":"string"},"enabled":{"description":"If this VPC is enabled or disabled.","type":"boolean"},"samplerate":{"description":"The samplerate of flows this VPC will send. Between 1 and 65535.","type":"integer","format":"int32","minimum":1,"maximum":65535},"region":{"type":"string","description":"The region the VPC is in. See <a href=\"/netography-docs/reference/get_api-v1-vpc-regions-flowtype\">Get VPC regions by flowtype</a> for a list of valid regions.\n"},"bucket":{"type":"string","description":"The Oracle Objectstorage bucket name."},"tenancy":{"type":"string","description":"Every Oracle Cloud Infrastructure resource has an Oracle-assigned unique ID called an Oracle Cloud Identifier (OCID)."},"userid":{"type":"string","description":"Oracle assigns each user a unique ID called an Oracle Cloud ID (OCID)."},"prefix":{"type":"string","description":"Optional folder prefix"},"tags":{"description":"An array of strings to tag every flow from this VPC with.","type":"array","items":{"type":"string"}}}}]}}}}}}},"400":{"description":"Bad Request. Typically due to a malformatted JSON body, or parameter values are not validating.","content":{"application/json":{"schema":{"allOf":[{"type":"object","required":["status","name","message"],"additionalProperties":false,"properties":{"status":{"description":"API response code: \n  * 4xx - you did something dumb\n  * 5xx - we did something dumb\n","type":"integer","readOnly":true,"format":"int32"},"name":{"description":"They type of error","type":"string","readOnly":true},"message":{"description":"description of the error","type":"string","readOnly":true}}},{"type":"object","properties":{"status":{},"name":{},"message":{}}}]}}}},"401":{"description":"Access token is missing or invalid","content":{"application/json":{"schema":{"allOf":[{"type":"object","required":["status","name","message"],"additionalProperties":false,"properties":{"status":{"description":"API response code: \n  * 4xx - you did something dumb\n  * 5xx - we did something dumb\n","type":"integer","readOnly":true,"format":"int32"},"name":{"description":"They type of error","type":"string","readOnly":true},"message":{"description":"description of the error","type":"string","readOnly":true}}},{"type":"object","properties":{"status":{},"name":{},"message":{}}}]}}}},"403":{"description":"Access is forbidden","content":{"application/json":{"schema":{"allOf":[{"type":"object","required":["status","name","message"],"additionalProperties":false,"properties":{"status":{"description":"API response code: \n  * 4xx - you did something dumb\n  * 5xx - we did something dumb\n","type":"integer","readOnly":true,"format":"int32"},"name":{"description":"They type of error","type":"string","readOnly":true},"message":{"description":"description of the error","type":"string","readOnly":true}}},{"type":"object","properties":{"status":{},"name":{},"message":{}}}]}}}},"default":{"description":"Unknown Error Occurred","content":{"application/json":{"schema":{"type":"object","required":["status","name","message"],"additionalProperties":false,"properties":{"status":{"description":"API response code: \n  * 4xx - you did something dumb\n  * 5xx - we did something dumb\n","type":"integer","readOnly":true,"format":"int32"},"name":{"description":"They type of error","type":"string","readOnly":true},"message":{"description":"description of the error","type":"string","readOnly":true}}}}}}}}}}}
```

## Create VPC

> Create a VPC from the supplied object.  Do NOT submit an ID.  IDs are auto generated and immutable.

```json
{"openapi":"3.0.0","info":{"title":"Netography APIs","version":"1.0"},"tags":[{"name":"Traffic Sources - VPCs"}],"servers":[{"url":"https://api.netography.com","description":"Netography API"}],"security":[{"BearerAuth":[]}],"components":{"securitySchemes":{"BearerAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}}},"paths":{"/api/v1/vpc":{"post":{"operationId":"v1_vpc_post","summary":"Create VPC","description":"Create a VPC from the supplied object.  Do NOT submit an ID.  IDs are auto generated and immutable.","requestBody":{"description":"VPC to be added","required":true,"content":{"application/json":{"schema":{"oneOf":[{"description":"AWS Kinesis Parameters.","type":"object","required":["flowtype","flowresource","name","enabled","samplerate","region","shardid","stream","awsauthtype"],"additionalProperties":false,"properties":{"flowtype":{"description":"The VPC's flowtype","type":"string","enum":["aws"]},"flowresource":{"description":"The VPC's resource used to transmit flow events.","type":"string","enum":["kinesis"]},"traffictype":{"description":"The VPC's traffic type. Can't be changed at updating.","type":"string","enum":["flow"]},"name":{"description":"The name of the VPC. Eg. prod-vpc-east","type":"string"},"enabled":{"description":"If this VPC is enabled or disabled.","type":"boolean"},"samplerate":{"description":"The samplerate of flows this VPC will send. Between 1 and 65535.","type":"integer","format":"int32","minimum":1,"maximum":65535},"region":{"type":"string","description":"The region the VPC is in. See <a href=\"/netography-docs/reference/get_api-v1-vpc-regions-flowtype\">Get VPC regions by flowtype</a> for a list of valid regions.\n"},"shardid":{"type":"string","description":"Kinesis shard id"},"stream":{"description":"Kinesis stream","type":"string"},"tags":{"description":"An array of strings to tag every flow from this VPC with.","type":"array","items":{"type":"string"}},"awsauthtype":{"description":"<p>The method of authentication to use with AWS.  Valid options are:</p> <ul> <li><code>AccessKey</code>: indicates key/secret auth. <code>accesskeyid</code> and <code>accesssecret</code> fields are then required.</li> <li><code>RoleARN</code> indicates that role auth.  The <code>role</code> object is then required.</li> </ul>\n","type":"string","enum":["AccessKey","RoleARN"]},"accesskeyid":{"description":"AWS accesskey id.  Required for <code>AccessKey</code> auth type.","type":"string"},"accesssecret":{"description":"AWS Access secret.  Required for <code>AccessKey</code> auth type.","type":"string"},"role":{"description":"object containing role authentication data.  Required for <code>RoleARN</code> auth type.","type":"object","properties":{"arn":{"description":"ARN used to authenticate the flow source","type":"string"}}}}},{"description":"AWS S3 Parameters","type":"object","required":["flowtype","flowresource","name","enabled","samplerate","bucket","bucketregion","region","awsauthtype"],"properties":{"flowtype":{"description":"The VPC's flowtype","type":"string","enum":["aws"]},"flowresource":{"description":"The VPC's resource used to transmit flow events.","type":"string","enum":["s3"]},"traffictype":{"description":"The VPC's traffic type. Can't be changed at updating.","type":"string","enum":["flow","dns"]},"name":{"description":"The name of the VPC. Eg. prod-vpc-east","type":"string"},"enabled":{"description":"If this VPC is enabled or disabled.","type":"boolean"},"samplerate":{"description":"The samplerate of flows this VPC will send. Between 1 and 65535.","type":"integer","format":"int32","minimum":1,"maximum":65535},"bucket":{"type":"string","description":"S3 bucket"},"bucketregion":{"type":"string","description":"Region this S3 bucket is in."},"hive":{"type":"string","description":"S3 Hive-compatible prefix"},"prefix":{"type":"string","description":"S3 flow log path prefix"},"region":{"type":"string","description":"The region the VPC is in. See <a href=\"/netography-docs/reference/get_api-v1-vpc-regions-flowtype\">Get VPC regions by flowtype</a> for a list of valid regions.\n"},"sqsurl":{"type":"string","description":"SQS URL of S3 events"},"tags":{"description":"An array of strings to tag every flow from this VPC with.","type":"array","items":{"type":"string"}},"awsauthtype":{"description":"<p>The method of authentication to use with AWS.  Valid options are:</p> <ul> <li><code>AccessKey</code>: indicates key/secret auth. <code>accesskeyid</code> and <code>accesssecret</code> fields are then required.</li> <li><code>RoleARN</code> indicates that role auth.  The <code>role</code> object is then required.</li> </ul>\n","type":"string","enum":["AccessKey","RoleARN"]},"accesskeyid":{"description":"AWS accesskey id.  Required for <code>AccessKey</code> auth type.","type":"string"},"accesssecret":{"description":"AWS Access secret.  Required for <code>AccessKey</code> auth type.","type":"string"},"role":{"description":"object containing role authentication data.  Required for <code>RoleARN</code> auth type.","type":"object","properties":{"arn":{"description":"ARN used to authenticate the flow source","type":"string"}}},"vpcid":{"description":"VPC ID of the source, applicable and required only for dns traffictype","type":"string"}}},{"description":"Azure Blobstorage Parameters","type":"object","required":["flowtype","flowresource","name","enabled","samplerate","region","accountname","accountkey","containername","networksecuritygroup","resourcegroup","subscriptionid"],"additionalProperties":false,"properties":{"flowtype":{"description":"The VPC's flowtype","type":"string","enum":["azure"]},"flowresource":{"description":"The VPC's resource used to transmit flow events.","type":"string","enum":["blobstorage"]},"traffictype":{"description":"The VPC's traffic type. Can't be changed at updating.","type":"string","enum":["flow"]},"name":{"description":"The name of the VPC. Eg. prod-vpc-east","type":"string"},"enabled":{"description":"If this VPC is enabled or disabled.","type":"boolean"},"samplerate":{"description":"The samplerate of flows this VPC will send. Between 1 and 65535.","type":"integer","format":"int32","minimum":1,"maximum":65535},"region":{"type":"string","description":"The region the VPC is in. See <a href=\"/netography-docs/reference/get_api-v1-vpc-regions-flowtype\">Get VPC regions by flowtype</a> for a list of valid regions.\n"},"accountname":{"type":"string","description":"Azure Storage Account's Access Name"},"accountkey":{"type":"string","description":"Azure Storage Account's Access Key"},"containername":{"type":"string","description":"Azure Storage Account's Container Name"},"networksecuritygroup":{"type":"string","description":"Azure Network Security Group's Name"},"resourcegroup":{"type":"string","description":"Azure Network Security Group's Resource Group"},"subscriptionid":{"type":"string","description":"Azure Network Security Group's subscription ID"},"tags":{"description":"An array of strings to tag every flow from this VPC with.","type":"array","items":{"type":"string"}}}},{"description":"Azure VNet Parameters","type":"object","required":["flowtype","flowresource","name","enabled","samplerate","region","accountname","accountkey","containername","networkwatcher","resourcegroup","subscriptionid","flowlog"],"additionalProperties":false,"properties":{"flowtype":{"description":"The VPC's flowtype","type":"string","enum":["azure-vnet"]},"flowresource":{"description":"The VPC's resource used to transmit flow events.","type":"string","enum":["blobstorage"]},"traffictype":{"description":"The VPC's traffic type. Can't be changed at updating.","type":"string","enum":["flow"]},"name":{"description":"The name of this flow source in Netography Fusion. Eg. prod-vpc-east","type":"string"},"enabled":{"description":"Enable or disable polling the cloud provider for samples","type":"boolean"},"samplerate":{"description":"The samplerate of flows this VPC will send. Between 1 and 65535.","type":"integer","format":"int32","minimum":1,"maximum":65535},"region":{"type":"string","description":"Virtual Network Region in Azure region format (lowercase with no spaces). Examples: eastus, centralus, westus2. See <a href=\"/netography-docs/reference/get_api-v1-vpc-regions-flowtype\">Get VPC regions by flowtype</a> for a list of valid regions.\n"},"accountname":{"type":"string","description":"Azure Storage Account Name where flow logs are stored"},"accountkey":{"type":"string","description":"Azure Storage Account's Access Key"},"containername":{"type":"string","description":"Azure Storage Account's Container Name. Use default of insights-logs-flowlogflowevent. Do not include leading spaces in the value.\n"},"networkwatcher":{"type":"string","description":"Azure Network Watcher's Name. Usually in format NetworkWatcher_region (e.g. NetworkWatcher_eastus).\n"},"resourcegroup":{"type":"string","description":"Azure Network Watcher's Resource Group. Use default of NETWORKWATCHERRG. Do not change unless you know what you're doing.\n"},"flowlog":{"type":"string","description":"Flow Log Name as shown in Network Watcher in Azure. This is a required field that identifies the specific flow log to collect.\n"},"subscriptionid":{"type":"string","description":"Network Watcher Subscription ID"},"tags":{"description":"An array of strings to tag every flow from this VPC with.","type":"array","items":{"type":"string"}}}},{"description":"GCP PubSub Parameters","type":"object","required":["flowtype","flowresource","name","enabled","samplerate","projectid","subid"],"additionalProperties":false,"properties":{"flowtype":{"description":"The VPC's flowtype","type":"string","enum":["gcp"]},"flowresource":{"description":"The VPC's resource used to transmit flow events.","type":"string","enum":["pubsub"]},"traffictype":{"description":"The VPC's traffic type. Can't be changed at updating.","type":"string","enum":["flow","dns"]},"name":{"description":"The name of the VPC. Eg. prod-vpc-east","type":"string"},"enabled":{"description":"If this VPC is enabled or disabled.","type":"boolean"},"samplerate":{"description":"The samplerate of flows this VPC will send. Between 1 and 65535.","type":"integer","format":"int32","minimum":1,"maximum":65535},"region":{"type":"string","description":"The region the VPC is in. See <a href=\"/netography-docs/reference/get_api-v1-vpc-regions-flowtype\">Get VPC regions by flowtype</a> for a list of valid regions.\n"},"projectid":{"type":"string","description":"GCP Project ID"},"subid":{"type":"string","description":"GCP PubSub Subscription ID"},"samplepercent":{"description":"Sample Rate Percent","type":"integer","format":"int32","minimum":1,"maximum":100},"tags":{"description":"An array of strings to tag every flow from this VPC with.","type":"array","items":{"type":"string"}}}},{"description":"IBM Objectstorage Parameters","type":"object","required":["flowtype","flowresource","name","enabled","samplerate","region","apikey","bucket","serviceinstanceid"],"additionalProperties":false,"properties":{"flowtype":{"description":"The VPC's flowtype","type":"string","enum":["ibm"]},"flowresource":{"description":"The VPC's resource used to transmit flow events.","type":"string","enum":["objectstorage"]},"traffictype":{"description":"The VPC's traffic type. Can't be changed at updating.","type":"string","enum":["flow"]},"name":{"description":"The name of the VPC. Eg. prod-vpc-east","type":"string"},"enabled":{"description":"If this VPC is enabled or disabled.","type":"boolean"},"samplerate":{"description":"The samplerate of flows this VPC will send. Between 1 and 65535.","type":"integer","format":"int32","minimum":1,"maximum":65535},"region":{"type":"string","description":"The region the VPC is in. See <a href=\"/netography-docs/reference/get_api-v1-vpc-regions-flowtype\">Get VPC regions by flowtype</a> for a list of valid regions.\n"},"apikey":{"type":"string","description":"IBM Objectstorage API key that is associated for the Service ID."},"bucket":{"type":"string","description":"The Objectstorage bucket name."},"prefix":{"type":"string","description":"Flow log path prefix"},"serviceinstanceid":{"type":"string","description":"Unique identifier for the instance of Object Storage the credential accesses. This is also referred to as a service credential."},"tags":{"description":"An array of strings to tag every flow from this VPC with.","type":"array","items":{"type":"string"}}}},{"description":"Oracle Objectstorage Parameters","type":"object","required":["flowtype","flowresource","name","enabled","samplerate","region","bucket","tenancy","userid"],"additionalProperties":false,"properties":{"flowtype":{"description":"The VPC's flowtype","type":"string","enum":["oracle"]},"flowresource":{"description":"The VPC's resource used to transmit flow events.","type":"string","enum":["objectstorage"]},"traffictype":{"description":"The VPC's traffic type. Can't be changed at updating.","type":"string","enum":["flow"]},"name":{"description":"The name of the VPC. Eg. prod-vpc-east","type":"string"},"enabled":{"description":"If this VPC is enabled or disabled.","type":"boolean"},"samplerate":{"description":"The samplerate of flows this VPC will send. Between 1 and 65535.","type":"integer","format":"int32","minimum":1,"maximum":65535},"region":{"type":"string","description":"The region the VPC is in. See <a href=\"/netography-docs/reference/get_api-v1-vpc-regions-flowtype\">Get VPC regions by flowtype</a> for a list of valid regions.\n"},"bucket":{"type":"string","description":"The Oracle Objectstorage bucket name."},"tenancy":{"type":"string","description":"Every Oracle Cloud Infrastructure resource has an Oracle-assigned unique ID called an Oracle Cloud Identifier (OCID)."},"userid":{"type":"string","description":"Oracle assigns each user a unique ID called an Oracle Cloud ID (OCID)."},"prefix":{"type":"string","description":"Optional folder prefix"},"tags":{"description":"An array of strings to tag every flow from this VPC with.","type":"array","items":{"type":"string"}}}}]}}}},"tags":["Traffic Sources - VPCs"],"responses":{"201":{"description":"List of VPCs Requested","content":{"application/json":{"schema":{"type":"object","additionalProperties":false,"properties":{"meta":{"type":"object","additionalProperties":false,"readOnly":true,"properties":{"code":{"description":"API response code.  200 ok, 400 you did something wrong.  500 we did something wrong","type":"integer","readOnly":true,"format":"int32"},"count":{"description":"Number of documents retrieved or updated.","type":"integer","readOnly":true,"format":"int32"}}},"data":{"description":"Result set from API call","type":"array","maxItems":1000,"items":{"additionalProperties":false,"properties":{"id":{"description":"VPC id","readOnly":true,"type":"string"}},"oneOf":[{"description":"AWS Kinesis Parameters.","type":"object","required":["flowtype","flowresource","name","enabled","samplerate","region","shardid","stream","awsauthtype"],"additionalProperties":false,"properties":{"flowtype":{"description":"The VPC's flowtype","type":"string","enum":["aws"]},"flowresource":{"description":"The VPC's resource used to transmit flow events.","type":"string","enum":["kinesis"]},"traffictype":{"description":"The VPC's traffic type. Can't be changed at updating.","type":"string","enum":["flow"]},"name":{"description":"The name of the VPC. Eg. prod-vpc-east","type":"string"},"enabled":{"description":"If this VPC is enabled or disabled.","type":"boolean"},"samplerate":{"description":"The samplerate of flows this VPC will send. Between 1 and 65535.","type":"integer","format":"int32","minimum":1,"maximum":65535},"region":{"type":"string","description":"The region the VPC is in. See <a href=\"/netography-docs/reference/get_api-v1-vpc-regions-flowtype\">Get VPC regions by flowtype</a> for a list of valid regions.\n"},"shardid":{"type":"string","description":"Kinesis shard id"},"stream":{"description":"Kinesis stream","type":"string"},"tags":{"description":"An array of strings to tag every flow from this VPC with.","type":"array","items":{"type":"string"}},"awsauthtype":{"description":"<p>The method of authentication to use with AWS.  Valid options are:</p> <ul> <li><code>AccessKey</code>: indicates key/secret auth. <code>accesskeyid</code> and <code>accesssecret</code> fields are then required.</li> <li><code>RoleARN</code> indicates that role auth.  The <code>role</code> object is then required.</li> </ul>\n","type":"string","enum":["AccessKey","RoleARN"]},"accesskeyid":{"description":"AWS accesskey id.  Required for <code>AccessKey</code> auth type.","type":"string"},"accesssecret":{"description":"AWS Access secret.  Required for <code>AccessKey</code> auth type.","type":"string"},"role":{"description":"object containing role authentication data.  Required for <code>RoleARN</code> auth type.","type":"object","properties":{"arn":{"description":"ARN used to authenticate the flow source","type":"string"}}}}},{"description":"AWS S3 Parameters","type":"object","required":["flowtype","flowresource","name","enabled","samplerate","bucket","bucketregion","region","awsauthtype"],"properties":{"flowtype":{"description":"The VPC's flowtype","type":"string","enum":["aws"]},"flowresource":{"description":"The VPC's resource used to transmit flow events.","type":"string","enum":["s3"]},"traffictype":{"description":"The VPC's traffic type. Can't be changed at updating.","type":"string","enum":["flow","dns"]},"name":{"description":"The name of the VPC. Eg. prod-vpc-east","type":"string"},"enabled":{"description":"If this VPC is enabled or disabled.","type":"boolean"},"samplerate":{"description":"The samplerate of flows this VPC will send. Between 1 and 65535.","type":"integer","format":"int32","minimum":1,"maximum":65535},"bucket":{"type":"string","description":"S3 bucket"},"bucketregion":{"type":"string","description":"Region this S3 bucket is in."},"hive":{"type":"string","description":"S3 Hive-compatible prefix"},"prefix":{"type":"string","description":"S3 flow log path prefix"},"region":{"type":"string","description":"The region the VPC is in. See <a href=\"/netography-docs/reference/get_api-v1-vpc-regions-flowtype\">Get VPC regions by flowtype</a> for a list of valid regions.\n"},"sqsurl":{"type":"string","description":"SQS URL of S3 events"},"tags":{"description":"An array of strings to tag every flow from this VPC with.","type":"array","items":{"type":"string"}},"awsauthtype":{"description":"<p>The method of authentication to use with AWS.  Valid options are:</p> <ul> <li><code>AccessKey</code>: indicates key/secret auth. <code>accesskeyid</code> and <code>accesssecret</code> fields are then required.</li> <li><code>RoleARN</code> indicates that role auth.  The <code>role</code> object is then required.</li> </ul>\n","type":"string","enum":["AccessKey","RoleARN"]},"accesskeyid":{"description":"AWS accesskey id.  Required for <code>AccessKey</code> auth type.","type":"string"},"accesssecret":{"description":"AWS Access secret.  Required for <code>AccessKey</code> auth type.","type":"string"},"role":{"description":"object containing role authentication data.  Required for <code>RoleARN</code> auth type.","type":"object","properties":{"arn":{"description":"ARN used to authenticate the flow source","type":"string"}}},"vpcid":{"description":"VPC ID of the source, applicable and required only for dns traffictype","type":"string"}}},{"description":"Azure Blobstorage Parameters","type":"object","required":["flowtype","flowresource","name","enabled","samplerate","region","accountname","accountkey","containername","networksecuritygroup","resourcegroup","subscriptionid"],"additionalProperties":false,"properties":{"flowtype":{"description":"The VPC's flowtype","type":"string","enum":["azure"]},"flowresource":{"description":"The VPC's resource used to transmit flow events.","type":"string","enum":["blobstorage"]},"traffictype":{"description":"The VPC's traffic type. Can't be changed at updating.","type":"string","enum":["flow"]},"name":{"description":"The name of the VPC. Eg. prod-vpc-east","type":"string"},"enabled":{"description":"If this VPC is enabled or disabled.","type":"boolean"},"samplerate":{"description":"The samplerate of flows this VPC will send. Between 1 and 65535.","type":"integer","format":"int32","minimum":1,"maximum":65535},"region":{"type":"string","description":"The region the VPC is in. See <a href=\"/netography-docs/reference/get_api-v1-vpc-regions-flowtype\">Get VPC regions by flowtype</a> for a list of valid regions.\n"},"accountname":{"type":"string","description":"Azure Storage Account's Access Name"},"accountkey":{"type":"string","description":"Azure Storage Account's Access Key"},"containername":{"type":"string","description":"Azure Storage Account's Container Name"},"networksecuritygroup":{"type":"string","description":"Azure Network Security Group's Name"},"resourcegroup":{"type":"string","description":"Azure Network Security Group's Resource Group"},"subscriptionid":{"type":"string","description":"Azure Network Security Group's subscription ID"},"tags":{"description":"An array of strings to tag every flow from this VPC with.","type":"array","items":{"type":"string"}}}},{"description":"GCP PubSub Parameters","type":"object","required":["flowtype","flowresource","name","enabled","samplerate","projectid","subid"],"additionalProperties":false,"properties":{"flowtype":{"description":"The VPC's flowtype","type":"string","enum":["gcp"]},"flowresource":{"description":"The VPC's resource used to transmit flow events.","type":"string","enum":["pubsub"]},"traffictype":{"description":"The VPC's traffic type. Can't be changed at updating.","type":"string","enum":["flow","dns"]},"name":{"description":"The name of the VPC. Eg. prod-vpc-east","type":"string"},"enabled":{"description":"If this VPC is enabled or disabled.","type":"boolean"},"samplerate":{"description":"The samplerate of flows this VPC will send. Between 1 and 65535.","type":"integer","format":"int32","minimum":1,"maximum":65535},"region":{"type":"string","description":"The region the VPC is in. See <a href=\"/netography-docs/reference/get_api-v1-vpc-regions-flowtype\">Get VPC regions by flowtype</a> for a list of valid regions.\n"},"projectid":{"type":"string","description":"GCP Project ID"},"subid":{"type":"string","description":"GCP PubSub Subscription ID"},"samplepercent":{"description":"Sample Rate Percent","type":"integer","format":"int32","minimum":1,"maximum":100},"tags":{"description":"An array of strings to tag every flow from this VPC with.","type":"array","items":{"type":"string"}}}},{"description":"IBM Objectstorage Parameters","type":"object","required":["flowtype","flowresource","name","enabled","samplerate","region","apikey","bucket","serviceinstanceid"],"additionalProperties":false,"properties":{"flowtype":{"description":"The VPC's flowtype","type":"string","enum":["ibm"]},"flowresource":{"description":"The VPC's resource used to transmit flow events.","type":"string","enum":["objectstorage"]},"traffictype":{"description":"The VPC's traffic type. Can't be changed at updating.","type":"string","enum":["flow"]},"name":{"description":"The name of the VPC. Eg. prod-vpc-east","type":"string"},"enabled":{"description":"If this VPC is enabled or disabled.","type":"boolean"},"samplerate":{"description":"The samplerate of flows this VPC will send. Between 1 and 65535.","type":"integer","format":"int32","minimum":1,"maximum":65535},"region":{"type":"string","description":"The region the VPC is in. See <a href=\"/netography-docs/reference/get_api-v1-vpc-regions-flowtype\">Get VPC regions by flowtype</a> for a list of valid regions.\n"},"apikey":{"type":"string","description":"IBM Objectstorage API key that is associated for the Service ID."},"bucket":{"type":"string","description":"The Objectstorage bucket name."},"prefix":{"type":"string","description":"Flow log path prefix"},"serviceinstanceid":{"type":"string","description":"Unique identifier for the instance of Object Storage the credential accesses. This is also referred to as a service credential."},"tags":{"description":"An array of strings to tag every flow from this VPC with.","type":"array","items":{"type":"string"}}}},{"description":"Oracle Objectstorage Parameters","type":"object","required":["flowtype","flowresource","name","enabled","samplerate","region","bucket","tenancy","userid"],"additionalProperties":false,"properties":{"flowtype":{"description":"The VPC's flowtype","type":"string","enum":["oracle"]},"flowresource":{"description":"The VPC's resource used to transmit flow events.","type":"string","enum":["objectstorage"]},"traffictype":{"description":"The VPC's traffic type. Can't be changed at updating.","type":"string","enum":["flow"]},"name":{"description":"The name of the VPC. Eg. prod-vpc-east","type":"string"},"enabled":{"description":"If this VPC is enabled or disabled.","type":"boolean"},"samplerate":{"description":"The samplerate of flows this VPC will send. Between 1 and 65535.","type":"integer","format":"int32","minimum":1,"maximum":65535},"region":{"type":"string","description":"The region the VPC is in. See <a href=\"/netography-docs/reference/get_api-v1-vpc-regions-flowtype\">Get VPC regions by flowtype</a> for a list of valid regions.\n"},"bucket":{"type":"string","description":"The Oracle Objectstorage bucket name."},"tenancy":{"type":"string","description":"Every Oracle Cloud Infrastructure resource has an Oracle-assigned unique ID called an Oracle Cloud Identifier (OCID)."},"userid":{"type":"string","description":"Oracle assigns each user a unique ID called an Oracle Cloud ID (OCID)."},"prefix":{"type":"string","description":"Optional folder prefix"},"tags":{"description":"An array of strings to tag every flow from this VPC with.","type":"array","items":{"type":"string"}}}}]}}}}}}},"400":{"description":"Bad Request. Typically due to a malformatted JSON body, or parameter values are not validating.","content":{"application/json":{"schema":{"allOf":[{"type":"object","required":["status","name","message"],"additionalProperties":false,"properties":{"status":{"description":"API response code: \n  * 4xx - you did something dumb\n  * 5xx - we did something dumb\n","type":"integer","readOnly":true,"format":"int32"},"name":{"description":"They type of error","type":"string","readOnly":true},"message":{"description":"description of the error","type":"string","readOnly":true}}},{"type":"object","properties":{"status":{},"name":{},"message":{}}}]}}}},"401":{"description":"Access token is missing or invalid","content":{"application/json":{"schema":{"allOf":[{"type":"object","required":["status","name","message"],"additionalProperties":false,"properties":{"status":{"description":"API response code: \n  * 4xx - you did something dumb\n  * 5xx - we did something dumb\n","type":"integer","readOnly":true,"format":"int32"},"name":{"description":"They type of error","type":"string","readOnly":true},"message":{"description":"description of the error","type":"string","readOnly":true}}},{"type":"object","properties":{"status":{},"name":{},"message":{}}}]}}}},"403":{"description":"Access is forbidden","content":{"application/json":{"schema":{"allOf":[{"type":"object","required":["status","name","message"],"additionalProperties":false,"properties":{"status":{"description":"API response code: \n  * 4xx - you did something dumb\n  * 5xx - we did something dumb\n","type":"integer","readOnly":true,"format":"int32"},"name":{"description":"They type of error","type":"string","readOnly":true},"message":{"description":"description of the error","type":"string","readOnly":true}}},{"type":"object","properties":{"status":{},"name":{},"message":{}}}]}}}},"default":{"description":"Unknown Error Occurred","content":{"application/json":{"schema":{"type":"object","required":["status","name","message"],"additionalProperties":false,"properties":{"status":{"description":"API response code: \n  * 4xx - you did something dumb\n  * 5xx - we did something dumb\n","type":"integer","readOnly":true,"format":"int32"},"name":{"description":"They type of error","type":"string","readOnly":true},"message":{"description":"description of the error","type":"string","readOnly":true}}}}}}}}}}}
```

## Get VPC by Name

> Fetches a specific VPC by the name supplied in the path.

```json
{"openapi":"3.0.0","info":{"title":"Netography APIs","version":"1.0"},"tags":[{"name":"Traffic Sources - VPCs"}],"servers":[{"url":"https://api.netography.com","description":"Netography API"}],"security":[{"BearerAuth":[]}],"components":{"securitySchemes":{"BearerAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}}},"paths":{"/api/v1/vpc/name/{name}":{"get":{"operationId":"v1_vpc_name_get","summary":"Get VPC by Name","description":"Fetches a specific VPC by the name supplied in the path.","tags":["Traffic Sources - VPCs"],"parameters":[{"name":"name","in":"path","required":true,"description":"The name of the VPC to fetch.","schema":{"type":"string"}}],"responses":{"200":{"description":"Object of a VPCs Requested","content":{"application/json":{"schema":{"type":"object","additionalProperties":false,"properties":{"meta":{"type":"object","additionalProperties":false,"readOnly":true,"properties":{"code":{"description":"API response code.  200 ok, 400 you did something wrong.  500 we did something wrong","type":"integer","readOnly":true,"format":"int32"},"count":{"description":"Number of documents retrieved or updated.","type":"integer","readOnly":true,"format":"int32"}}},"data":{"description":"Result set from API call","type":"object","additionalProperties":false,"properties":{"id":{"description":"VPC id","readOnly":true,"type":"string"}},"oneOf":[{"description":"AWS Kinesis Parameters.","type":"object","required":["flowtype","flowresource","name","enabled","samplerate","region","shardid","stream","awsauthtype"],"additionalProperties":false,"properties":{"flowtype":{"description":"The VPC's flowtype","type":"string","enum":["aws"]},"flowresource":{"description":"The VPC's resource used to transmit flow events.","type":"string","enum":["kinesis"]},"traffictype":{"description":"The VPC's traffic type. Can't be changed at updating.","type":"string","enum":["flow"]},"name":{"description":"The name of the VPC. Eg. prod-vpc-east","type":"string"},"enabled":{"description":"If this VPC is enabled or disabled.","type":"boolean"},"samplerate":{"description":"The samplerate of flows this VPC will send. Between 1 and 65535.","type":"integer","format":"int32","minimum":1,"maximum":65535},"region":{"type":"string","description":"The region the VPC is in. See <a href=\"/netography-docs/reference/get_api-v1-vpc-regions-flowtype\">Get VPC regions by flowtype</a> for a list of valid regions.\n"},"shardid":{"type":"string","description":"Kinesis shard id"},"stream":{"description":"Kinesis stream","type":"string"},"tags":{"description":"An array of strings to tag every flow from this VPC with.","type":"array","items":{"type":"string"}},"awsauthtype":{"description":"<p>The method of authentication to use with AWS.  Valid options are:</p> <ul> <li><code>AccessKey</code>: indicates key/secret auth. <code>accesskeyid</code> and <code>accesssecret</code> fields are then required.</li> <li><code>RoleARN</code> indicates that role auth.  The <code>role</code> object is then required.</li> </ul>\n","type":"string","enum":["AccessKey","RoleARN"]},"accesskeyid":{"description":"AWS accesskey id.  Required for <code>AccessKey</code> auth type.","type":"string"},"accesssecret":{"description":"AWS Access secret.  Required for <code>AccessKey</code> auth type.","type":"string"},"role":{"description":"object containing role authentication data.  Required for <code>RoleARN</code> auth type.","type":"object","properties":{"arn":{"description":"ARN used to authenticate the flow source","type":"string"}}}}},{"description":"AWS S3 Parameters","type":"object","required":["flowtype","flowresource","name","enabled","samplerate","bucket","bucketregion","region","awsauthtype"],"properties":{"flowtype":{"description":"The VPC's flowtype","type":"string","enum":["aws"]},"flowresource":{"description":"The VPC's resource used to transmit flow events.","type":"string","enum":["s3"]},"traffictype":{"description":"The VPC's traffic type. Can't be changed at updating.","type":"string","enum":["flow","dns"]},"name":{"description":"The name of the VPC. Eg. prod-vpc-east","type":"string"},"enabled":{"description":"If this VPC is enabled or disabled.","type":"boolean"},"samplerate":{"description":"The samplerate of flows this VPC will send. Between 1 and 65535.","type":"integer","format":"int32","minimum":1,"maximum":65535},"bucket":{"type":"string","description":"S3 bucket"},"bucketregion":{"type":"string","description":"Region this S3 bucket is in."},"hive":{"type":"string","description":"S3 Hive-compatible prefix"},"prefix":{"type":"string","description":"S3 flow log path prefix"},"region":{"type":"string","description":"The region the VPC is in. See <a href=\"/netography-docs/reference/get_api-v1-vpc-regions-flowtype\">Get VPC regions by flowtype</a> for a list of valid regions.\n"},"sqsurl":{"type":"string","description":"SQS URL of S3 events"},"tags":{"description":"An array of strings to tag every flow from this VPC with.","type":"array","items":{"type":"string"}},"awsauthtype":{"description":"<p>The method of authentication to use with AWS.  Valid options are:</p> <ul> <li><code>AccessKey</code>: indicates key/secret auth. <code>accesskeyid</code> and <code>accesssecret</code> fields are then required.</li> <li><code>RoleARN</code> indicates that role auth.  The <code>role</code> object is then required.</li> </ul>\n","type":"string","enum":["AccessKey","RoleARN"]},"accesskeyid":{"description":"AWS accesskey id.  Required for <code>AccessKey</code> auth type.","type":"string"},"accesssecret":{"description":"AWS Access secret.  Required for <code>AccessKey</code> auth type.","type":"string"},"role":{"description":"object containing role authentication data.  Required for <code>RoleARN</code> auth type.","type":"object","properties":{"arn":{"description":"ARN used to authenticate the flow source","type":"string"}}},"vpcid":{"description":"VPC ID of the source, applicable and required only for dns traffictype","type":"string"}}},{"description":"Azure Blobstorage Parameters","type":"object","required":["flowtype","flowresource","name","enabled","samplerate","region","accountname","accountkey","containername","networksecuritygroup","resourcegroup","subscriptionid"],"additionalProperties":false,"properties":{"flowtype":{"description":"The VPC's flowtype","type":"string","enum":["azure"]},"flowresource":{"description":"The VPC's resource used to transmit flow events.","type":"string","enum":["blobstorage"]},"traffictype":{"description":"The VPC's traffic type. Can't be changed at updating.","type":"string","enum":["flow"]},"name":{"description":"The name of the VPC. Eg. prod-vpc-east","type":"string"},"enabled":{"description":"If this VPC is enabled or disabled.","type":"boolean"},"samplerate":{"description":"The samplerate of flows this VPC will send. Between 1 and 65535.","type":"integer","format":"int32","minimum":1,"maximum":65535},"region":{"type":"string","description":"The region the VPC is in. See <a href=\"/netography-docs/reference/get_api-v1-vpc-regions-flowtype\">Get VPC regions by flowtype</a> for a list of valid regions.\n"},"accountname":{"type":"string","description":"Azure Storage Account's Access Name"},"accountkey":{"type":"string","description":"Azure Storage Account's Access Key"},"containername":{"type":"string","description":"Azure Storage Account's Container Name"},"networksecuritygroup":{"type":"string","description":"Azure Network Security Group's Name"},"resourcegroup":{"type":"string","description":"Azure Network Security Group's Resource Group"},"subscriptionid":{"type":"string","description":"Azure Network Security Group's subscription ID"},"tags":{"description":"An array of strings to tag every flow from this VPC with.","type":"array","items":{"type":"string"}}}},{"description":"GCP PubSub Parameters","type":"object","required":["flowtype","flowresource","name","enabled","samplerate","projectid","subid"],"additionalProperties":false,"properties":{"flowtype":{"description":"The VPC's flowtype","type":"string","enum":["gcp"]},"flowresource":{"description":"The VPC's resource used to transmit flow events.","type":"string","enum":["pubsub"]},"traffictype":{"description":"The VPC's traffic type. Can't be changed at updating.","type":"string","enum":["flow","dns"]},"name":{"description":"The name of the VPC. Eg. prod-vpc-east","type":"string"},"enabled":{"description":"If this VPC is enabled or disabled.","type":"boolean"},"samplerate":{"description":"The samplerate of flows this VPC will send. Between 1 and 65535.","type":"integer","format":"int32","minimum":1,"maximum":65535},"region":{"type":"string","description":"The region the VPC is in. See <a href=\"/netography-docs/reference/get_api-v1-vpc-regions-flowtype\">Get VPC regions by flowtype</a> for a list of valid regions.\n"},"projectid":{"type":"string","description":"GCP Project ID"},"subid":{"type":"string","description":"GCP PubSub Subscription ID"},"samplepercent":{"description":"Sample Rate Percent","type":"integer","format":"int32","minimum":1,"maximum":100},"tags":{"description":"An array of strings to tag every flow from this VPC with.","type":"array","items":{"type":"string"}}}},{"description":"IBM Objectstorage Parameters","type":"object","required":["flowtype","flowresource","name","enabled","samplerate","region","apikey","bucket","serviceinstanceid"],"additionalProperties":false,"properties":{"flowtype":{"description":"The VPC's flowtype","type":"string","enum":["ibm"]},"flowresource":{"description":"The VPC's resource used to transmit flow events.","type":"string","enum":["objectstorage"]},"traffictype":{"description":"The VPC's traffic type. Can't be changed at updating.","type":"string","enum":["flow"]},"name":{"description":"The name of the VPC. Eg. prod-vpc-east","type":"string"},"enabled":{"description":"If this VPC is enabled or disabled.","type":"boolean"},"samplerate":{"description":"The samplerate of flows this VPC will send. Between 1 and 65535.","type":"integer","format":"int32","minimum":1,"maximum":65535},"region":{"type":"string","description":"The region the VPC is in. See <a href=\"/netography-docs/reference/get_api-v1-vpc-regions-flowtype\">Get VPC regions by flowtype</a> for a list of valid regions.\n"},"apikey":{"type":"string","description":"IBM Objectstorage API key that is associated for the Service ID."},"bucket":{"type":"string","description":"The Objectstorage bucket name."},"prefix":{"type":"string","description":"Flow log path prefix"},"serviceinstanceid":{"type":"string","description":"Unique identifier for the instance of Object Storage the credential accesses. This is also referred to as a service credential."},"tags":{"description":"An array of strings to tag every flow from this VPC with.","type":"array","items":{"type":"string"}}}},{"description":"Oracle Objectstorage Parameters","type":"object","required":["flowtype","flowresource","name","enabled","samplerate","region","bucket","tenancy","userid"],"additionalProperties":false,"properties":{"flowtype":{"description":"The VPC's flowtype","type":"string","enum":["oracle"]},"flowresource":{"description":"The VPC's resource used to transmit flow events.","type":"string","enum":["objectstorage"]},"traffictype":{"description":"The VPC's traffic type. Can't be changed at updating.","type":"string","enum":["flow"]},"name":{"description":"The name of the VPC. Eg. prod-vpc-east","type":"string"},"enabled":{"description":"If this VPC is enabled or disabled.","type":"boolean"},"samplerate":{"description":"The samplerate of flows this VPC will send. Between 1 and 65535.","type":"integer","format":"int32","minimum":1,"maximum":65535},"region":{"type":"string","description":"The region the VPC is in. See <a href=\"/netography-docs/reference/get_api-v1-vpc-regions-flowtype\">Get VPC regions by flowtype</a> for a list of valid regions.\n"},"bucket":{"type":"string","description":"The Oracle Objectstorage bucket name."},"tenancy":{"type":"string","description":"Every Oracle Cloud Infrastructure resource has an Oracle-assigned unique ID called an Oracle Cloud Identifier (OCID)."},"userid":{"type":"string","description":"Oracle assigns each user a unique ID called an Oracle Cloud ID (OCID)."},"prefix":{"type":"string","description":"Optional folder prefix"},"tags":{"description":"An array of strings to tag every flow from this VPC with.","type":"array","items":{"type":"string"}}}}]}}}}}},"400":{"description":"Bad Request. Typically due to a malformatted JSON body, or parameter values are not validating.","content":{"application/json":{"schema":{"allOf":[{"type":"object","required":["status","name","message"],"additionalProperties":false,"properties":{"status":{"description":"API response code: \n  * 4xx - you did something dumb\n  * 5xx - we did something dumb\n","type":"integer","readOnly":true,"format":"int32"},"name":{"description":"They type of error","type":"string","readOnly":true},"message":{"description":"description of the error","type":"string","readOnly":true}}},{"type":"object","properties":{"status":{},"name":{},"message":{}}}]}}}},"401":{"description":"Access token is missing or invalid","content":{"application/json":{"schema":{"allOf":[{"type":"object","required":["status","name","message"],"additionalProperties":false,"properties":{"status":{"description":"API response code: \n  * 4xx - you did something dumb\n  * 5xx - we did something dumb\n","type":"integer","readOnly":true,"format":"int32"},"name":{"description":"They type of error","type":"string","readOnly":true},"message":{"description":"description of the error","type":"string","readOnly":true}}},{"type":"object","properties":{"status":{},"name":{},"message":{}}}]}}}},"403":{"description":"Access is forbidden","content":{"application/json":{"schema":{"allOf":[{"type":"object","required":["status","name","message"],"additionalProperties":false,"properties":{"status":{"description":"API response code: \n  * 4xx - you did something dumb\n  * 5xx - we did something dumb\n","type":"integer","readOnly":true,"format":"int32"},"name":{"description":"They type of error","type":"string","readOnly":true},"message":{"description":"description of the error","type":"string","readOnly":true}}},{"type":"object","properties":{"status":{},"name":{},"message":{}}}]}}}},"default":{"description":"Unknown Error Occurred","content":{"application/json":{"schema":{"type":"object","required":["status","name","message"],"additionalProperties":false,"properties":{"status":{"description":"API response code: \n  * 4xx - you did something dumb\n  * 5xx - we did something dumb\n","type":"integer","readOnly":true,"format":"int32"},"name":{"description":"They type of error","type":"string","readOnly":true},"message":{"description":"description of the error","type":"string","readOnly":true}}}}}}}}}}}
```

## Get VPC

> Fetches a specific VPC from the ID supplied in the path.

```json
{"openapi":"3.0.0","info":{"title":"Netography APIs","version":"1.0"},"tags":[{"name":"Traffic Sources - VPCs"}],"servers":[{"url":"https://api.netography.com","description":"Netography API"}],"security":[{"BearerAuth":[]}],"components":{"securitySchemes":{"BearerAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}}},"paths":{"/api/v1/vpc/{id}":{"get":{"operationId":"v1_vpc_id_get","summary":"Get VPC","description":"Fetches a specific VPC from the ID supplied in the path.","tags":["Traffic Sources - VPCs"],"parameters":[{"in":"path","name":"id","schema":{"type":"integer"},"required":true,"description":"Numeric ID of the VPC to get"}],"responses":{"200":{"description":"Object of a VPCs Requested","content":{"application/json":{"schema":{"type":"object","additionalProperties":false,"properties":{"meta":{"type":"object","additionalProperties":false,"readOnly":true,"properties":{"code":{"description":"API response code.  200 ok, 400 you did something wrong.  500 we did something wrong","type":"integer","readOnly":true,"format":"int32"},"count":{"description":"Number of documents retrieved or updated.","type":"integer","readOnly":true,"format":"int32"}}},"data":{"description":"Result set from API call","type":"object","additionalProperties":false,"properties":{"id":{"description":"VPC id","readOnly":true,"type":"string"}},"oneOf":[{"description":"AWS Kinesis Parameters.","type":"object","required":["flowtype","flowresource","name","enabled","samplerate","region","shardid","stream","awsauthtype"],"additionalProperties":false,"properties":{"flowtype":{"description":"The VPC's flowtype","type":"string","enum":["aws"]},"flowresource":{"description":"The VPC's resource used to transmit flow events.","type":"string","enum":["kinesis"]},"traffictype":{"description":"The VPC's traffic type. Can't be changed at updating.","type":"string","enum":["flow"]},"name":{"description":"The name of the VPC. Eg. prod-vpc-east","type":"string"},"enabled":{"description":"If this VPC is enabled or disabled.","type":"boolean"},"samplerate":{"description":"The samplerate of flows this VPC will send. Between 1 and 65535.","type":"integer","format":"int32","minimum":1,"maximum":65535},"region":{"type":"string","description":"The region the VPC is in. See <a href=\"/netography-docs/reference/get_api-v1-vpc-regions-flowtype\">Get VPC regions by flowtype</a> for a list of valid regions.\n"},"shardid":{"type":"string","description":"Kinesis shard id"},"stream":{"description":"Kinesis stream","type":"string"},"tags":{"description":"An array of strings to tag every flow from this VPC with.","type":"array","items":{"type":"string"}},"awsauthtype":{"description":"<p>The method of authentication to use with AWS.  Valid options are:</p> <ul> <li><code>AccessKey</code>: indicates key/secret auth. <code>accesskeyid</code> and <code>accesssecret</code> fields are then required.</li> <li><code>RoleARN</code> indicates that role auth.  The <code>role</code> object is then required.</li> </ul>\n","type":"string","enum":["AccessKey","RoleARN"]},"accesskeyid":{"description":"AWS accesskey id.  Required for <code>AccessKey</code> auth type.","type":"string"},"accesssecret":{"description":"AWS Access secret.  Required for <code>AccessKey</code> auth type.","type":"string"},"role":{"description":"object containing role authentication data.  Required for <code>RoleARN</code> auth type.","type":"object","properties":{"arn":{"description":"ARN used to authenticate the flow source","type":"string"}}}}},{"description":"AWS S3 Parameters","type":"object","required":["flowtype","flowresource","name","enabled","samplerate","bucket","bucketregion","region","awsauthtype"],"properties":{"flowtype":{"description":"The VPC's flowtype","type":"string","enum":["aws"]},"flowresource":{"description":"The VPC's resource used to transmit flow events.","type":"string","enum":["s3"]},"traffictype":{"description":"The VPC's traffic type. Can't be changed at updating.","type":"string","enum":["flow","dns"]},"name":{"description":"The name of the VPC. Eg. prod-vpc-east","type":"string"},"enabled":{"description":"If this VPC is enabled or disabled.","type":"boolean"},"samplerate":{"description":"The samplerate of flows this VPC will send. Between 1 and 65535.","type":"integer","format":"int32","minimum":1,"maximum":65535},"bucket":{"type":"string","description":"S3 bucket"},"bucketregion":{"type":"string","description":"Region this S3 bucket is in."},"hive":{"type":"string","description":"S3 Hive-compatible prefix"},"prefix":{"type":"string","description":"S3 flow log path prefix"},"region":{"type":"string","description":"The region the VPC is in. See <a href=\"/netography-docs/reference/get_api-v1-vpc-regions-flowtype\">Get VPC regions by flowtype</a> for a list of valid regions.\n"},"sqsurl":{"type":"string","description":"SQS URL of S3 events"},"tags":{"description":"An array of strings to tag every flow from this VPC with.","type":"array","items":{"type":"string"}},"awsauthtype":{"description":"<p>The method of authentication to use with AWS.  Valid options are:</p> <ul> <li><code>AccessKey</code>: indicates key/secret auth. <code>accesskeyid</code> and <code>accesssecret</code> fields are then required.</li> <li><code>RoleARN</code> indicates that role auth.  The <code>role</code> object is then required.</li> </ul>\n","type":"string","enum":["AccessKey","RoleARN"]},"accesskeyid":{"description":"AWS accesskey id.  Required for <code>AccessKey</code> auth type.","type":"string"},"accesssecret":{"description":"AWS Access secret.  Required for <code>AccessKey</code> auth type.","type":"string"},"role":{"description":"object containing role authentication data.  Required for <code>RoleARN</code> auth type.","type":"object","properties":{"arn":{"description":"ARN used to authenticate the flow source","type":"string"}}},"vpcid":{"description":"VPC ID of the source, applicable and required only for dns traffictype","type":"string"}}},{"description":"Azure Blobstorage Parameters","type":"object","required":["flowtype","flowresource","name","enabled","samplerate","region","accountname","accountkey","containername","networksecuritygroup","resourcegroup","subscriptionid"],"additionalProperties":false,"properties":{"flowtype":{"description":"The VPC's flowtype","type":"string","enum":["azure"]},"flowresource":{"description":"The VPC's resource used to transmit flow events.","type":"string","enum":["blobstorage"]},"traffictype":{"description":"The VPC's traffic type. Can't be changed at updating.","type":"string","enum":["flow"]},"name":{"description":"The name of the VPC. Eg. prod-vpc-east","type":"string"},"enabled":{"description":"If this VPC is enabled or disabled.","type":"boolean"},"samplerate":{"description":"The samplerate of flows this VPC will send. Between 1 and 65535.","type":"integer","format":"int32","minimum":1,"maximum":65535},"region":{"type":"string","description":"The region the VPC is in. See <a href=\"/netography-docs/reference/get_api-v1-vpc-regions-flowtype\">Get VPC regions by flowtype</a> for a list of valid regions.\n"},"accountname":{"type":"string","description":"Azure Storage Account's Access Name"},"accountkey":{"type":"string","description":"Azure Storage Account's Access Key"},"containername":{"type":"string","description":"Azure Storage Account's Container Name"},"networksecuritygroup":{"type":"string","description":"Azure Network Security Group's Name"},"resourcegroup":{"type":"string","description":"Azure Network Security Group's Resource Group"},"subscriptionid":{"type":"string","description":"Azure Network Security Group's subscription ID"},"tags":{"description":"An array of strings to tag every flow from this VPC with.","type":"array","items":{"type":"string"}}}},{"description":"GCP PubSub Parameters","type":"object","required":["flowtype","flowresource","name","enabled","samplerate","projectid","subid"],"additionalProperties":false,"properties":{"flowtype":{"description":"The VPC's flowtype","type":"string","enum":["gcp"]},"flowresource":{"description":"The VPC's resource used to transmit flow events.","type":"string","enum":["pubsub"]},"traffictype":{"description":"The VPC's traffic type. Can't be changed at updating.","type":"string","enum":["flow","dns"]},"name":{"description":"The name of the VPC. Eg. prod-vpc-east","type":"string"},"enabled":{"description":"If this VPC is enabled or disabled.","type":"boolean"},"samplerate":{"description":"The samplerate of flows this VPC will send. Between 1 and 65535.","type":"integer","format":"int32","minimum":1,"maximum":65535},"region":{"type":"string","description":"The region the VPC is in. See <a href=\"/netography-docs/reference/get_api-v1-vpc-regions-flowtype\">Get VPC regions by flowtype</a> for a list of valid regions.\n"},"projectid":{"type":"string","description":"GCP Project ID"},"subid":{"type":"string","description":"GCP PubSub Subscription ID"},"samplepercent":{"description":"Sample Rate Percent","type":"integer","format":"int32","minimum":1,"maximum":100},"tags":{"description":"An array of strings to tag every flow from this VPC with.","type":"array","items":{"type":"string"}}}},{"description":"IBM Objectstorage Parameters","type":"object","required":["flowtype","flowresource","name","enabled","samplerate","region","apikey","bucket","serviceinstanceid"],"additionalProperties":false,"properties":{"flowtype":{"description":"The VPC's flowtype","type":"string","enum":["ibm"]},"flowresource":{"description":"The VPC's resource used to transmit flow events.","type":"string","enum":["objectstorage"]},"traffictype":{"description":"The VPC's traffic type. Can't be changed at updating.","type":"string","enum":["flow"]},"name":{"description":"The name of the VPC. Eg. prod-vpc-east","type":"string"},"enabled":{"description":"If this VPC is enabled or disabled.","type":"boolean"},"samplerate":{"description":"The samplerate of flows this VPC will send. Between 1 and 65535.","type":"integer","format":"int32","minimum":1,"maximum":65535},"region":{"type":"string","description":"The region the VPC is in. See <a href=\"/netography-docs/reference/get_api-v1-vpc-regions-flowtype\">Get VPC regions by flowtype</a> for a list of valid regions.\n"},"apikey":{"type":"string","description":"IBM Objectstorage API key that is associated for the Service ID."},"bucket":{"type":"string","description":"The Objectstorage bucket name."},"prefix":{"type":"string","description":"Flow log path prefix"},"serviceinstanceid":{"type":"string","description":"Unique identifier for the instance of Object Storage the credential accesses. This is also referred to as a service credential."},"tags":{"description":"An array of strings to tag every flow from this VPC with.","type":"array","items":{"type":"string"}}}},{"description":"Oracle Objectstorage Parameters","type":"object","required":["flowtype","flowresource","name","enabled","samplerate","region","bucket","tenancy","userid"],"additionalProperties":false,"properties":{"flowtype":{"description":"The VPC's flowtype","type":"string","enum":["oracle"]},"flowresource":{"description":"The VPC's resource used to transmit flow events.","type":"string","enum":["objectstorage"]},"traffictype":{"description":"The VPC's traffic type. Can't be changed at updating.","type":"string","enum":["flow"]},"name":{"description":"The name of the VPC. Eg. prod-vpc-east","type":"string"},"enabled":{"description":"If this VPC is enabled or disabled.","type":"boolean"},"samplerate":{"description":"The samplerate of flows this VPC will send. Between 1 and 65535.","type":"integer","format":"int32","minimum":1,"maximum":65535},"region":{"type":"string","description":"The region the VPC is in. See <a href=\"/netography-docs/reference/get_api-v1-vpc-regions-flowtype\">Get VPC regions by flowtype</a> for a list of valid regions.\n"},"bucket":{"type":"string","description":"The Oracle Objectstorage bucket name."},"tenancy":{"type":"string","description":"Every Oracle Cloud Infrastructure resource has an Oracle-assigned unique ID called an Oracle Cloud Identifier (OCID)."},"userid":{"type":"string","description":"Oracle assigns each user a unique ID called an Oracle Cloud ID (OCID)."},"prefix":{"type":"string","description":"Optional folder prefix"},"tags":{"description":"An array of strings to tag every flow from this VPC with.","type":"array","items":{"type":"string"}}}}]}}}}}},"400":{"description":"Bad Request. Typically due to a malformatted JSON body, or parameter values are not validating.","content":{"application/json":{"schema":{"allOf":[{"type":"object","required":["status","name","message"],"additionalProperties":false,"properties":{"status":{"description":"API response code: \n  * 4xx - you did something dumb\n  * 5xx - we did something dumb\n","type":"integer","readOnly":true,"format":"int32"},"name":{"description":"They type of error","type":"string","readOnly":true},"message":{"description":"description of the error","type":"string","readOnly":true}}},{"type":"object","properties":{"status":{},"name":{},"message":{}}}]}}}},"401":{"description":"Access token is missing or invalid","content":{"application/json":{"schema":{"allOf":[{"type":"object","required":["status","name","message"],"additionalProperties":false,"properties":{"status":{"description":"API response code: \n  * 4xx - you did something dumb\n  * 5xx - we did something dumb\n","type":"integer","readOnly":true,"format":"int32"},"name":{"description":"They type of error","type":"string","readOnly":true},"message":{"description":"description of the error","type":"string","readOnly":true}}},{"type":"object","properties":{"status":{},"name":{},"message":{}}}]}}}},"403":{"description":"Access is forbidden","content":{"application/json":{"schema":{"allOf":[{"type":"object","required":["status","name","message"],"additionalProperties":false,"properties":{"status":{"description":"API response code: \n  * 4xx - you did something dumb\n  * 5xx - we did something dumb\n","type":"integer","readOnly":true,"format":"int32"},"name":{"description":"They type of error","type":"string","readOnly":true},"message":{"description":"description of the error","type":"string","readOnly":true}}},{"type":"object","properties":{"status":{},"name":{},"message":{}}}]}}}},"default":{"description":"Unknown Error Occurred","content":{"application/json":{"schema":{"type":"object","required":["status","name","message"],"additionalProperties":false,"properties":{"status":{"description":"API response code: \n  * 4xx - you did something dumb\n  * 5xx - we did something dumb\n","type":"integer","readOnly":true,"format":"int32"},"name":{"description":"They type of error","type":"string","readOnly":true},"message":{"description":"description of the error","type":"string","readOnly":true}}}}}}}}}}}
```

## Update VPC

> Update a VPC given the provided object.  This does not do a diff.  You must send the complete object.

```json
{"openapi":"3.0.0","info":{"title":"Netography APIs","version":"1.0"},"tags":[{"name":"Traffic Sources - VPCs"}],"servers":[{"url":"https://api.netography.com","description":"Netography API"}],"security":[{"BearerAuth":[]}],"components":{"securitySchemes":{"BearerAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}}},"paths":{"/api/v1/vpc/{id}":{"put":{"operationId":"v1_vpc_id_put","summary":"Update VPC","description":"Update a VPC given the provided object.  This does not do a diff.  You must send the complete object.","requestBody":{"description":"VPC to be updated","required":true,"content":{"application/json":{"schema":{"oneOf":[{"description":"AWS Kinesis Parameters.","type":"object","required":["flowtype","flowresource","name","enabled","samplerate","region","shardid","stream","awsauthtype"],"additionalProperties":false,"properties":{"flowtype":{"description":"The VPC's flowtype","type":"string","enum":["aws"]},"flowresource":{"description":"The VPC's resource used to transmit flow events.","type":"string","enum":["kinesis"]},"traffictype":{"description":"The VPC's traffic type. Can't be changed at updating.","type":"string","enum":["flow"]},"name":{"description":"The name of the VPC. Eg. prod-vpc-east","type":"string"},"enabled":{"description":"If this VPC is enabled or disabled.","type":"boolean"},"samplerate":{"description":"The samplerate of flows this VPC will send. Between 1 and 65535.","type":"integer","format":"int32","minimum":1,"maximum":65535},"region":{"type":"string","description":"The region the VPC is in. See <a href=\"/netography-docs/reference/get_api-v1-vpc-regions-flowtype\">Get VPC regions by flowtype</a> for a list of valid regions.\n"},"shardid":{"type":"string","description":"Kinesis shard id"},"stream":{"description":"Kinesis stream","type":"string"},"tags":{"description":"An array of strings to tag every flow from this VPC with.","type":"array","items":{"type":"string"}},"awsauthtype":{"description":"<p>The method of authentication to use with AWS.  Valid options are:</p> <ul> <li><code>AccessKey</code>: indicates key/secret auth. <code>accesskeyid</code> and <code>accesssecret</code> fields are then required.</li> <li><code>RoleARN</code> indicates that role auth.  The <code>role</code> object is then required.</li> </ul>\n","type":"string","enum":["AccessKey","RoleARN"]},"accesskeyid":{"description":"AWS accesskey id.  Required for <code>AccessKey</code> auth type.","type":"string"},"accesssecret":{"description":"AWS Access secret.  Required for <code>AccessKey</code> auth type.","type":"string"},"role":{"description":"object containing role authentication data.  Required for <code>RoleARN</code> auth type.","type":"object","properties":{"arn":{"description":"ARN used to authenticate the flow source","type":"string"}}}}},{"description":"AWS S3 Parameters","type":"object","required":["flowtype","flowresource","name","enabled","samplerate","bucket","bucketregion","region","awsauthtype"],"properties":{"flowtype":{"description":"The VPC's flowtype","type":"string","enum":["aws"]},"flowresource":{"description":"The VPC's resource used to transmit flow events.","type":"string","enum":["s3"]},"traffictype":{"description":"The VPC's traffic type. Can't be changed at updating.","type":"string","enum":["flow","dns"]},"name":{"description":"The name of the VPC. Eg. prod-vpc-east","type":"string"},"enabled":{"description":"If this VPC is enabled or disabled.","type":"boolean"},"samplerate":{"description":"The samplerate of flows this VPC will send. Between 1 and 65535.","type":"integer","format":"int32","minimum":1,"maximum":65535},"bucket":{"type":"string","description":"S3 bucket"},"bucketregion":{"type":"string","description":"Region this S3 bucket is in."},"hive":{"type":"string","description":"S3 Hive-compatible prefix"},"prefix":{"type":"string","description":"S3 flow log path prefix"},"region":{"type":"string","description":"The region the VPC is in. See <a href=\"/netography-docs/reference/get_api-v1-vpc-regions-flowtype\">Get VPC regions by flowtype</a> for a list of valid regions.\n"},"sqsurl":{"type":"string","description":"SQS URL of S3 events"},"tags":{"description":"An array of strings to tag every flow from this VPC with.","type":"array","items":{"type":"string"}},"awsauthtype":{"description":"<p>The method of authentication to use with AWS.  Valid options are:</p> <ul> <li><code>AccessKey</code>: indicates key/secret auth. <code>accesskeyid</code> and <code>accesssecret</code> fields are then required.</li> <li><code>RoleARN</code> indicates that role auth.  The <code>role</code> object is then required.</li> </ul>\n","type":"string","enum":["AccessKey","RoleARN"]},"accesskeyid":{"description":"AWS accesskey id.  Required for <code>AccessKey</code> auth type.","type":"string"},"accesssecret":{"description":"AWS Access secret.  Required for <code>AccessKey</code> auth type.","type":"string"},"role":{"description":"object containing role authentication data.  Required for <code>RoleARN</code> auth type.","type":"object","properties":{"arn":{"description":"ARN used to authenticate the flow source","type":"string"}}},"vpcid":{"description":"VPC ID of the source, applicable and required only for dns traffictype","type":"string"}}},{"description":"Azure Blobstorage Parameters","type":"object","required":["flowtype","flowresource","name","enabled","samplerate","region","accountname","accountkey","containername","networksecuritygroup","resourcegroup","subscriptionid"],"additionalProperties":false,"properties":{"flowtype":{"description":"The VPC's flowtype","type":"string","enum":["azure"]},"flowresource":{"description":"The VPC's resource used to transmit flow events.","type":"string","enum":["blobstorage"]},"traffictype":{"description":"The VPC's traffic type. Can't be changed at updating.","type":"string","enum":["flow"]},"name":{"description":"The name of the VPC. Eg. prod-vpc-east","type":"string"},"enabled":{"description":"If this VPC is enabled or disabled.","type":"boolean"},"samplerate":{"description":"The samplerate of flows this VPC will send. Between 1 and 65535.","type":"integer","format":"int32","minimum":1,"maximum":65535},"region":{"type":"string","description":"The region the VPC is in. See <a href=\"/netography-docs/reference/get_api-v1-vpc-regions-flowtype\">Get VPC regions by flowtype</a> for a list of valid regions.\n"},"accountname":{"type":"string","description":"Azure Storage Account's Access Name"},"accountkey":{"type":"string","description":"Azure Storage Account's Access Key"},"containername":{"type":"string","description":"Azure Storage Account's Container Name"},"networksecuritygroup":{"type":"string","description":"Azure Network Security Group's Name"},"resourcegroup":{"type":"string","description":"Azure Network Security Group's Resource Group"},"subscriptionid":{"type":"string","description":"Azure Network Security Group's subscription ID"},"tags":{"description":"An array of strings to tag every flow from this VPC with.","type":"array","items":{"type":"string"}}}},{"description":"Azure VNet Parameters","type":"object","required":["flowtype","flowresource","name","enabled","samplerate","region","accountname","accountkey","containername","networkwatcher","resourcegroup","subscriptionid","flowlog"],"additionalProperties":false,"properties":{"flowtype":{"description":"The VPC's flowtype","type":"string","enum":["azure-vnet"]},"flowresource":{"description":"The VPC's resource used to transmit flow events.","type":"string","enum":["blobstorage"]},"traffictype":{"description":"The VPC's traffic type. Can't be changed at updating.","type":"string","enum":["flow"]},"name":{"description":"The name of this flow source in Netography Fusion. Eg. prod-vpc-east","type":"string"},"enabled":{"description":"Enable or disable polling the cloud provider for samples","type":"boolean"},"samplerate":{"description":"The samplerate of flows this VPC will send. Between 1 and 65535.","type":"integer","format":"int32","minimum":1,"maximum":65535},"region":{"type":"string","description":"Virtual Network Region in Azure region format (lowercase with no spaces). Examples: eastus, centralus, westus2. See <a href=\"/netography-docs/reference/get_api-v1-vpc-regions-flowtype\">Get VPC regions by flowtype</a> for a list of valid regions.\n"},"accountname":{"type":"string","description":"Azure Storage Account Name where flow logs are stored"},"accountkey":{"type":"string","description":"Azure Storage Account's Access Key"},"containername":{"type":"string","description":"Azure Storage Account's Container Name. Use default of insights-logs-flowlogflowevent. Do not include leading spaces in the value.\n"},"networkwatcher":{"type":"string","description":"Azure Network Watcher's Name. Usually in format NetworkWatcher_region (e.g. NetworkWatcher_eastus).\n"},"resourcegroup":{"type":"string","description":"Azure Network Watcher's Resource Group. Use default of NETWORKWATCHERRG. Do not change unless you know what you're doing.\n"},"flowlog":{"type":"string","description":"Flow Log Name as shown in Network Watcher in Azure. This is a required field that identifies the specific flow log to collect.\n"},"subscriptionid":{"type":"string","description":"Network Watcher Subscription ID"},"tags":{"description":"An array of strings to tag every flow from this VPC with.","type":"array","items":{"type":"string"}}}},{"description":"GCP PubSub Parameters","type":"object","required":["flowtype","flowresource","name","enabled","samplerate","projectid","subid"],"additionalProperties":false,"properties":{"flowtype":{"description":"The VPC's flowtype","type":"string","enum":["gcp"]},"flowresource":{"description":"The VPC's resource used to transmit flow events.","type":"string","enum":["pubsub"]},"traffictype":{"description":"The VPC's traffic type. Can't be changed at updating.","type":"string","enum":["flow","dns"]},"name":{"description":"The name of the VPC. Eg. prod-vpc-east","type":"string"},"enabled":{"description":"If this VPC is enabled or disabled.","type":"boolean"},"samplerate":{"description":"The samplerate of flows this VPC will send. Between 1 and 65535.","type":"integer","format":"int32","minimum":1,"maximum":65535},"region":{"type":"string","description":"The region the VPC is in. See <a href=\"/netography-docs/reference/get_api-v1-vpc-regions-flowtype\">Get VPC regions by flowtype</a> for a list of valid regions.\n"},"projectid":{"type":"string","description":"GCP Project ID"},"subid":{"type":"string","description":"GCP PubSub Subscription ID"},"samplepercent":{"description":"Sample Rate Percent","type":"integer","format":"int32","minimum":1,"maximum":100},"tags":{"description":"An array of strings to tag every flow from this VPC with.","type":"array","items":{"type":"string"}}}},{"description":"IBM Objectstorage Parameters","type":"object","required":["flowtype","flowresource","name","enabled","samplerate","region","apikey","bucket","serviceinstanceid"],"additionalProperties":false,"properties":{"flowtype":{"description":"The VPC's flowtype","type":"string","enum":["ibm"]},"flowresource":{"description":"The VPC's resource used to transmit flow events.","type":"string","enum":["objectstorage"]},"traffictype":{"description":"The VPC's traffic type. Can't be changed at updating.","type":"string","enum":["flow"]},"name":{"description":"The name of the VPC. Eg. prod-vpc-east","type":"string"},"enabled":{"description":"If this VPC is enabled or disabled.","type":"boolean"},"samplerate":{"description":"The samplerate of flows this VPC will send. Between 1 and 65535.","type":"integer","format":"int32","minimum":1,"maximum":65535},"region":{"type":"string","description":"The region the VPC is in. See <a href=\"/netography-docs/reference/get_api-v1-vpc-regions-flowtype\">Get VPC regions by flowtype</a> for a list of valid regions.\n"},"apikey":{"type":"string","description":"IBM Objectstorage API key that is associated for the Service ID."},"bucket":{"type":"string","description":"The Objectstorage bucket name."},"prefix":{"type":"string","description":"Flow log path prefix"},"serviceinstanceid":{"type":"string","description":"Unique identifier for the instance of Object Storage the credential accesses. This is also referred to as a service credential."},"tags":{"description":"An array of strings to tag every flow from this VPC with.","type":"array","items":{"type":"string"}}}},{"description":"Oracle Objectstorage Parameters","type":"object","required":["flowtype","flowresource","name","enabled","samplerate","region","bucket","tenancy","userid"],"additionalProperties":false,"properties":{"flowtype":{"description":"The VPC's flowtype","type":"string","enum":["oracle"]},"flowresource":{"description":"The VPC's resource used to transmit flow events.","type":"string","enum":["objectstorage"]},"traffictype":{"description":"The VPC's traffic type. Can't be changed at updating.","type":"string","enum":["flow"]},"name":{"description":"The name of the VPC. Eg. prod-vpc-east","type":"string"},"enabled":{"description":"If this VPC is enabled or disabled.","type":"boolean"},"samplerate":{"description":"The samplerate of flows this VPC will send. Between 1 and 65535.","type":"integer","format":"int32","minimum":1,"maximum":65535},"region":{"type":"string","description":"The region the VPC is in. See <a href=\"/netography-docs/reference/get_api-v1-vpc-regions-flowtype\">Get VPC regions by flowtype</a> for a list of valid regions.\n"},"bucket":{"type":"string","description":"The Oracle Objectstorage bucket name."},"tenancy":{"type":"string","description":"Every Oracle Cloud Infrastructure resource has an Oracle-assigned unique ID called an Oracle Cloud Identifier (OCID)."},"userid":{"type":"string","description":"Oracle assigns each user a unique ID called an Oracle Cloud ID (OCID)."},"prefix":{"type":"string","description":"Optional folder prefix"},"tags":{"description":"An array of strings to tag every flow from this VPC with.","type":"array","items":{"type":"string"}}}}]}}}},"tags":["Traffic Sources - VPCs"],"parameters":[{"name":"id","in":"path","required":true,"description":"The ID of the VPC to be updated","schema":{"type":"string"}}],"responses":{"200":{"description":"List of VPCs Requested","content":{"application/json":{"schema":{"type":"object","additionalProperties":false,"properties":{"meta":{"type":"object","additionalProperties":false,"readOnly":true,"properties":{"code":{"description":"API response code.  200 ok, 400 you did something wrong.  500 we did something wrong","type":"integer","readOnly":true,"format":"int32"},"count":{"description":"Number of documents retrieved or updated.","type":"integer","readOnly":true,"format":"int32"}}},"data":{"description":"Result set from API call","type":"array","maxItems":1000,"items":{"additionalProperties":false,"properties":{"id":{"description":"VPC id","readOnly":true,"type":"string"}},"oneOf":[{"description":"AWS Kinesis Parameters.","type":"object","required":["flowtype","flowresource","name","enabled","samplerate","region","shardid","stream","awsauthtype"],"additionalProperties":false,"properties":{"flowtype":{"description":"The VPC's flowtype","type":"string","enum":["aws"]},"flowresource":{"description":"The VPC's resource used to transmit flow events.","type":"string","enum":["kinesis"]},"traffictype":{"description":"The VPC's traffic type. Can't be changed at updating.","type":"string","enum":["flow"]},"name":{"description":"The name of the VPC. Eg. prod-vpc-east","type":"string"},"enabled":{"description":"If this VPC is enabled or disabled.","type":"boolean"},"samplerate":{"description":"The samplerate of flows this VPC will send. Between 1 and 65535.","type":"integer","format":"int32","minimum":1,"maximum":65535},"region":{"type":"string","description":"The region the VPC is in. See <a href=\"/netography-docs/reference/get_api-v1-vpc-regions-flowtype\">Get VPC regions by flowtype</a> for a list of valid regions.\n"},"shardid":{"type":"string","description":"Kinesis shard id"},"stream":{"description":"Kinesis stream","type":"string"},"tags":{"description":"An array of strings to tag every flow from this VPC with.","type":"array","items":{"type":"string"}},"awsauthtype":{"description":"<p>The method of authentication to use with AWS.  Valid options are:</p> <ul> <li><code>AccessKey</code>: indicates key/secret auth. <code>accesskeyid</code> and <code>accesssecret</code> fields are then required.</li> <li><code>RoleARN</code> indicates that role auth.  The <code>role</code> object is then required.</li> </ul>\n","type":"string","enum":["AccessKey","RoleARN"]},"accesskeyid":{"description":"AWS accesskey id.  Required for <code>AccessKey</code> auth type.","type":"string"},"accesssecret":{"description":"AWS Access secret.  Required for <code>AccessKey</code> auth type.","type":"string"},"role":{"description":"object containing role authentication data.  Required for <code>RoleARN</code> auth type.","type":"object","properties":{"arn":{"description":"ARN used to authenticate the flow source","type":"string"}}}}},{"description":"AWS S3 Parameters","type":"object","required":["flowtype","flowresource","name","enabled","samplerate","bucket","bucketregion","region","awsauthtype"],"properties":{"flowtype":{"description":"The VPC's flowtype","type":"string","enum":["aws"]},"flowresource":{"description":"The VPC's resource used to transmit flow events.","type":"string","enum":["s3"]},"traffictype":{"description":"The VPC's traffic type. Can't be changed at updating.","type":"string","enum":["flow","dns"]},"name":{"description":"The name of the VPC. Eg. prod-vpc-east","type":"string"},"enabled":{"description":"If this VPC is enabled or disabled.","type":"boolean"},"samplerate":{"description":"The samplerate of flows this VPC will send. Between 1 and 65535.","type":"integer","format":"int32","minimum":1,"maximum":65535},"bucket":{"type":"string","description":"S3 bucket"},"bucketregion":{"type":"string","description":"Region this S3 bucket is in."},"hive":{"type":"string","description":"S3 Hive-compatible prefix"},"prefix":{"type":"string","description":"S3 flow log path prefix"},"region":{"type":"string","description":"The region the VPC is in. See <a href=\"/netography-docs/reference/get_api-v1-vpc-regions-flowtype\">Get VPC regions by flowtype</a> for a list of valid regions.\n"},"sqsurl":{"type":"string","description":"SQS URL of S3 events"},"tags":{"description":"An array of strings to tag every flow from this VPC with.","type":"array","items":{"type":"string"}},"awsauthtype":{"description":"<p>The method of authentication to use with AWS.  Valid options are:</p> <ul> <li><code>AccessKey</code>: indicates key/secret auth. <code>accesskeyid</code> and <code>accesssecret</code> fields are then required.</li> <li><code>RoleARN</code> indicates that role auth.  The <code>role</code> object is then required.</li> </ul>\n","type":"string","enum":["AccessKey","RoleARN"]},"accesskeyid":{"description":"AWS accesskey id.  Required for <code>AccessKey</code> auth type.","type":"string"},"accesssecret":{"description":"AWS Access secret.  Required for <code>AccessKey</code> auth type.","type":"string"},"role":{"description":"object containing role authentication data.  Required for <code>RoleARN</code> auth type.","type":"object","properties":{"arn":{"description":"ARN used to authenticate the flow source","type":"string"}}},"vpcid":{"description":"VPC ID of the source, applicable and required only for dns traffictype","type":"string"}}},{"description":"Azure Blobstorage Parameters","type":"object","required":["flowtype","flowresource","name","enabled","samplerate","region","accountname","accountkey","containername","networksecuritygroup","resourcegroup","subscriptionid"],"additionalProperties":false,"properties":{"flowtype":{"description":"The VPC's flowtype","type":"string","enum":["azure"]},"flowresource":{"description":"The VPC's resource used to transmit flow events.","type":"string","enum":["blobstorage"]},"traffictype":{"description":"The VPC's traffic type. Can't be changed at updating.","type":"string","enum":["flow"]},"name":{"description":"The name of the VPC. Eg. prod-vpc-east","type":"string"},"enabled":{"description":"If this VPC is enabled or disabled.","type":"boolean"},"samplerate":{"description":"The samplerate of flows this VPC will send. Between 1 and 65535.","type":"integer","format":"int32","minimum":1,"maximum":65535},"region":{"type":"string","description":"The region the VPC is in. See <a href=\"/netography-docs/reference/get_api-v1-vpc-regions-flowtype\">Get VPC regions by flowtype</a> for a list of valid regions.\n"},"accountname":{"type":"string","description":"Azure Storage Account's Access Name"},"accountkey":{"type":"string","description":"Azure Storage Account's Access Key"},"containername":{"type":"string","description":"Azure Storage Account's Container Name"},"networksecuritygroup":{"type":"string","description":"Azure Network Security Group's Name"},"resourcegroup":{"type":"string","description":"Azure Network Security Group's Resource Group"},"subscriptionid":{"type":"string","description":"Azure Network Security Group's subscription ID"},"tags":{"description":"An array of strings to tag every flow from this VPC with.","type":"array","items":{"type":"string"}}}},{"description":"GCP PubSub Parameters","type":"object","required":["flowtype","flowresource","name","enabled","samplerate","projectid","subid"],"additionalProperties":false,"properties":{"flowtype":{"description":"The VPC's flowtype","type":"string","enum":["gcp"]},"flowresource":{"description":"The VPC's resource used to transmit flow events.","type":"string","enum":["pubsub"]},"traffictype":{"description":"The VPC's traffic type. Can't be changed at updating.","type":"string","enum":["flow","dns"]},"name":{"description":"The name of the VPC. Eg. prod-vpc-east","type":"string"},"enabled":{"description":"If this VPC is enabled or disabled.","type":"boolean"},"samplerate":{"description":"The samplerate of flows this VPC will send. Between 1 and 65535.","type":"integer","format":"int32","minimum":1,"maximum":65535},"region":{"type":"string","description":"The region the VPC is in. See <a href=\"/netography-docs/reference/get_api-v1-vpc-regions-flowtype\">Get VPC regions by flowtype</a> for a list of valid regions.\n"},"projectid":{"type":"string","description":"GCP Project ID"},"subid":{"type":"string","description":"GCP PubSub Subscription ID"},"samplepercent":{"description":"Sample Rate Percent","type":"integer","format":"int32","minimum":1,"maximum":100},"tags":{"description":"An array of strings to tag every flow from this VPC with.","type":"array","items":{"type":"string"}}}},{"description":"IBM Objectstorage Parameters","type":"object","required":["flowtype","flowresource","name","enabled","samplerate","region","apikey","bucket","serviceinstanceid"],"additionalProperties":false,"properties":{"flowtype":{"description":"The VPC's flowtype","type":"string","enum":["ibm"]},"flowresource":{"description":"The VPC's resource used to transmit flow events.","type":"string","enum":["objectstorage"]},"traffictype":{"description":"The VPC's traffic type. Can't be changed at updating.","type":"string","enum":["flow"]},"name":{"description":"The name of the VPC. Eg. prod-vpc-east","type":"string"},"enabled":{"description":"If this VPC is enabled or disabled.","type":"boolean"},"samplerate":{"description":"The samplerate of flows this VPC will send. Between 1 and 65535.","type":"integer","format":"int32","minimum":1,"maximum":65535},"region":{"type":"string","description":"The region the VPC is in. See <a href=\"/netography-docs/reference/get_api-v1-vpc-regions-flowtype\">Get VPC regions by flowtype</a> for a list of valid regions.\n"},"apikey":{"type":"string","description":"IBM Objectstorage API key that is associated for the Service ID."},"bucket":{"type":"string","description":"The Objectstorage bucket name."},"prefix":{"type":"string","description":"Flow log path prefix"},"serviceinstanceid":{"type":"string","description":"Unique identifier for the instance of Object Storage the credential accesses. This is also referred to as a service credential."},"tags":{"description":"An array of strings to tag every flow from this VPC with.","type":"array","items":{"type":"string"}}}},{"description":"Oracle Objectstorage Parameters","type":"object","required":["flowtype","flowresource","name","enabled","samplerate","region","bucket","tenancy","userid"],"additionalProperties":false,"properties":{"flowtype":{"description":"The VPC's flowtype","type":"string","enum":["oracle"]},"flowresource":{"description":"The VPC's resource used to transmit flow events.","type":"string","enum":["objectstorage"]},"traffictype":{"description":"The VPC's traffic type. Can't be changed at updating.","type":"string","enum":["flow"]},"name":{"description":"The name of the VPC. Eg. prod-vpc-east","type":"string"},"enabled":{"description":"If this VPC is enabled or disabled.","type":"boolean"},"samplerate":{"description":"The samplerate of flows this VPC will send. Between 1 and 65535.","type":"integer","format":"int32","minimum":1,"maximum":65535},"region":{"type":"string","description":"The region the VPC is in. See <a href=\"/netography-docs/reference/get_api-v1-vpc-regions-flowtype\">Get VPC regions by flowtype</a> for a list of valid regions.\n"},"bucket":{"type":"string","description":"The Oracle Objectstorage bucket name."},"tenancy":{"type":"string","description":"Every Oracle Cloud Infrastructure resource has an Oracle-assigned unique ID called an Oracle Cloud Identifier (OCID)."},"userid":{"type":"string","description":"Oracle assigns each user a unique ID called an Oracle Cloud ID (OCID)."},"prefix":{"type":"string","description":"Optional folder prefix"},"tags":{"description":"An array of strings to tag every flow from this VPC with.","type":"array","items":{"type":"string"}}}}]}}}}}}},"400":{"description":"Bad Request. Typically due to a malformatted JSON body, or parameter va
[...]
